
Rem *******************TIMER DO LUTOWNICY*************************
Rem * Wersja:1.0                                                 *
Rem * Kompilator: Bascom-AVR: 1.11.7.4                           *
Rem * Autor: Karol Gnys                                          *
Rem * E-mail:calon@wp.pl                                         *
Rem * Rok: 2018                                                  *
Rem **************************************************************

'ATMEGA8: fusebit=cksel=1111 sut=10        'USTAW FUSEBITY
$regfile = "m8def.dat"                                      'wybor mikroprocesora
$crystal = 8000000                                          'wybor rezonatora

Config Portc = Output                                       'portc jako wyjsciowy
Portc = &B11111111
Config Portb = Output                                       'portb jako wyjsciowy
Portb = &B11111111

Config Timer0 = Timer , Prescale = 256 ;                    'konfiguracja timer0 dla obslugi wyswietlacza
On Timer0 Wyswietlacz                                       'skocz do obslugi wyswietlacza
Enable Interrupts
Enable Timer0
Load Timer0 , 150

Config Int0 = Falling                                       'przerwanie wywolane opadajacym niskim stanem W1
Config Int1 = Falling                                       'przerwanie wywolane opadajacym stanem niskim W2


Config Pinb.5 = Output                                      'wyjscie lini g wyswietlacza LED
Portb.5 = 1                                                 'stan spoczynkowy 1
Segg Alias Portb.5                                          'przypisanie nazwy segg portowi portb5

Config Pind.1 = Output                                      'wyjscie syngalizatora piezzo
Portd.1 = 1                                                 'stan spoczynkowy 1
Piezzo Alias Portd.6

Config Pind.6 = Output                                      'wyjscie diody sygnalizacyjnej czerwonej
Portd.6 = 1                                                 'stan spoczynkowy 1
Czerwona Alias Portd.6

Config Pind.7 = Output                                      'wyjscie diody sygnalizacyjnej zoltej i optoizolacji
Portd.7 = 1                                                 'stan spoczynkowy 1
Zolta Alias Portd.7

Config Pind.2 = Input                                       'konfiguracja lini jako wejscia
Portd.2 = 1                                                 'wlaczenie rezystora podciagajacego
W1 Alias Pind.2                                             'przypisanie nazwy W1 do wejscia portd.2

Config Pind.3 = Input                                       'konfiguracja lini jako wejscia
Portd.3 = 1                                                 'wlaczenie rezystora podciagajacego
W2 Alias Pind.3


Dim Licznik As Bit                                          'zmienna zmiany wyswietlacza
Dim Jednostki As Integer                                    'zmienna jednosci wyswietlacza
Dim Dziesiatki As Integer                                   'zmienna dziesiatek wyswietlacza
Jednostki = 11                                              'wyswietla przypisany znak przy pierwszym uruchomieniu
Dziesiatki = 11                                             'wyswietla przypisany znak przy pierwszym uruchomieniu

Dim Zapisz As Bit                                           'zmienna wyjscia z ustawien i ich zapisu
Zapisz = 0
Dim Czas As Byte                                            'zmienna w ktorej zapisany jest czas pracy lutownicy
Dim Liczba As Single                                        'zmienna konwersji liczb
Dim Liczba1 As Single                                       'zmienna pomocnicza konwersji liczb
Dim Zezwolenie As Bit                                       'zmienna zwzwalajaca na zliczanie
Dim Zezwolenie1 As Bit                                      'zmienna zezwalajaca na sygnal dzwiekowy
Zezwolenie1 = 0
Dim Petla As Byte                                           'zmienna do petli sygnalu dzwiekowego przekroczenia warosci
Dim Czas2 As Byte                                           'zmienna w ktorej zapisanyjest glowny czas
Dim Czas3 As Byte                                           'zmienna petli odliczania czasu
Dim Zezwolenie2 As Bit                                      'zmienna zezwalajaca z przerwania W1
Zezwolenie2 = 0
Dim Minuta As Byte                                          'zmienna do odliczania minutowego odcinku  czasu
Dim Kasujminute As Bit                                      'zmienna wyjscia z petli for
Kasujminute = 0

Readeeprom Czas2 , 1                                        'odczytuje pamiec eeprom z ustawieniami zmiennej czasu pracy

If Czas2 < 1 Or Czas2 > 30 Then                             'warunek spelniony kiedy w eepromie nieustalona wartosc
   Czas2 = 10                                               ' zapisz do zmiennej czas poczatkowy 10 minut
End If

If W1 = 0 Then                                              'jezeli nacisnieto przycisk W1 idz do ustawiania czasu
   Waitms 20
      If W1 = 0 Then
          Czas = 1
          Liczba = Czas
          Reset Czerwona
          Zezwolenie = 1
          Zezwolenie1 = 1
          Sound Portd.1 , 300 , 100
          Wait 1
         Gosub Ustawienieczasu
      End If
End If

Enable Int0
On Int0 Przerwanie1
Enable Int1
On Int1 Przerwanie2


Do                                                          'PETLA GLOWNA
   Jednostki = 11
   Dziesiatki = 11

If Zezwolenie2 = 1 Then
   Czas3 = Czas2
   Zezwolenie2 = 0
   Gosub Odliczanieczasu
End If

Loop
End


Przerwanie1:
   Czas3 = Czas2
   Zezwolenie2 = 1
   Kasujminute = 1
   Sound Portd.1 , 300 , 100
Return


Przerwanie2:
   Czas3 = 0
   Kasujminute = 1
   Zezwolenie2 = 0
   Sound Portd.1 , 300 , 100
Return


Ustawienieczasu:
Do
   Reset Czerwona
If W1 = 0 Then
   Waitms 20
      If W1 = 0 Then
        If Zezwolenie = 1 Then
            Incr Czas
            Set Czerwona
            Sound Portd.1 , 300 , 100
        End If
      End If
     Waitms 300
End If
Liczba = Czas
Gosub Cyfry
If Czas >= 30 Then                                          'maksymalna liczba czasu pracy lutownicy
      Czas = 30
      Zezwolenie = 0
   If Zezwolenie1 = 1 Then
For Petla = 1 To 3
      Gosub Alarm2
      Next Petla
Zezwolenie1 = 0
End If
End If

If W2 = 0 Then
      Waitms 20
  If W2 = 0 Then
      Zapisz = 1
      Czas2 = Czas
  End If
End If

Loop Until Zapisz = 1
Zapisz = 0
Writeeeprom Czas2 , 1
Set Czerwona
Gifr.6 = 1                                                  'bit zerujacy zgloszenie od przerwan int0 int1
Return


Odliczanieczasu:
While Czas3 > 0

If Czas3 > 1 Then
Set Czerwona
End If


If Czas3 = 1 Then
      Liczba = Czas3
      Gosub Cyfry
      Reset Czerwona
      Gosub Alarm1
   End If



      Zezwolenie2 = 0
      Reset Zolta
      Liczba = Czas3
      Gosub Cyfry
      Minuta = 0
      Kasujminute = 0
   For Minuta = 1 To 60
      Wait 1
   If Kasujminute = 1 Then
      Exit For
   End If
   Next Minuta

   If Czas3 > 0 Then
      Decr Czas3
  End If


  If Zezwolenie2 = 1 Then
      Czas3 = Czas2
      Zezwolenie2 = 0
  End If


Wend

 Set Zolta
 Set Czerwona
 Zezwolenie2 = 0
Return


Alarm1:                                                     'sygnalizacja akustyczna -mniej niz minuta
       Sound Portd.1 , 400 , 400
       Sound Portd.1 , 800 , 500
Return


Alarm2:                                                     'sygnalizacja akustyczna osiagniecia maksymalnej wartosci ustawianego czasu
      Sound Portd.1 , 300 , 100
      Sound Portd.1 , 400 , 250
Return


Cyfry:
      Dziesiatki = Liczba \ 10                              'ze zmiennej liczba wyluskaj liczbe dziesiatek
      Liczba1 = Dziesiatki * 10
      Jednostki = Liczba - Liczba1                          'wyluskaj liczbe jednostek
Return


Wyswietlacz:                                                'procedura obslugi wyswietlacza 2LED
Load Timer0 , 150
If Licznik = 0 Then
   Portc = Lookup(jednostki , Kod7seg)                      'wyswietla jednostki na wyswietlaczu LED
   Set Portb.3                                              'wylacz i wlacza odpowiedni wyswietlacz
   Reset Portb.4

Select Case Jednostki                                       'wlacza lub wylacza segment g wyswietlacza LED
      Case 0:
         Set Segg
      Case 1:
         Set Segg
      Case 2:
         Reset Segg
      Case 3:
         Reset Segg
      Case 4:
         Reset Segg
      Case 5:
         Reset Segg
      Case 6:
         Reset Segg
      Case 7:
         Set Segg
      Case 8:
         Reset Segg
      Case 9:
         Reset Segg
      Case 10:
         Reset Segg
      Case 11:
         Reset Segg
End Select
      Licznik = 1

Else

Portc = Lookup(dziesiatki , Kod7seg)                        'wyswietla dziesiatki na wyswietlaczu LED
      Set Portb.4
      Reset Portb.3
Select Case Dziesiatki
      Case 0:
         Set Segg
      Case 1:
         Set Segg
      Case 2:
         Reset Segg
      Case 3:
         Reset Segg
      Case 4:
         Reset Segg
      Case 5:
         Reset Segg
      Case 6:
         Reset Segg
      Case 7:
         Set Segg
      Case 8:
         Reset Segg
      Case 9:
         Reset Segg
      Case 10:
         Reset Segg
      Case 11:
         Reset Segg
End Select
Licznik = 0
End If
Return


Kod7seg:                                                    'tabela cyfr dla wyswietlacza LED
Data 192 , 249 , 164 , 176 , 153 , 146 , 130 , 248 , 128 , 144 , 6 , 255
Rem    0     1     2     3     4     5     6     7     8     9    C    -